/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.util.*;
public class Cell {

  static int hexWidth = 6;  //4; // 8;
  static int hexHeight = 9;  //6; //12;
  int x;
  int y;
  int gridx;
  int gridy;

  public Cell(int cx,int cy,int gx,int gy) {
  x=cx; y=cy; gridx=gx; gridy=gy;
  }
  void drawCell(Graphics g, Grid mygrid)
  {
    int hexside = hexHeight/3;
    int a = x-(hexWidth/2);
    int b = y - hexside;
    int c = x + (hexWidth/2);
    int d = y + hexside;
    int e = y + (2 * hexside);

    g.setColor(Color.lightGray);
    g.drawLine(a,y,x,b);
    g.drawLine(x,b,c,y);
    g.drawLine(c,y,c,d);
    g.drawLine(c,d,x,e);
    g.drawLine(x,e,a,d);
    g.drawLine(a,d,a,y);

  }
  void fillCell(Graphics g, Grid mygrid)
  {
    int xarr[],yarr[];
    int hexside = hexHeight/3;
    int a = x-(hexWidth/2);
    int b = y - hexside;
    int c = x + (hexWidth/2);
    int d = y + hexside;
    int e = y + (2 * hexside);
    xarr = new int [6];
    yarr = new int [6];
    xarr[0] = a+1; xarr[1]=x; xarr[2]=c; xarr[3]=c; xarr[4]=x; xarr[5]=a+1;
    yarr[0] = y; yarr[1]=b; yarr[2]=y; yarr[3]=d; yarr[4]=e; yarr[5]=d;
    g.setColor(mygrid.getColor(gridx,gridy));
    g.fillPolygon(xarr,yarr,6);
    g.setColor(Color.lightGray);
    drawCell(g,mygrid);
   // g.drawLine(c,d,x,e);
  }

  boolean pointPresentInHexCell(int px, int py)
  {
    int hexside = hexHeight/3;
    int a = x-(hexWidth/2);
    int b = y - hexside;
    int c = x + (hexWidth/2);
    int e = y + (2 * hexside);

    if(px >= a && px <= c && py >= b && py <= e)
      return true;
    return false;
  }
}